/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


// NOT REVISED FOR TRAKLA2

package content.exercises;

import matrix.structures.FDT.*;
import matrix.structures.FDT.probe.VanillaTable;

public class BMH_Algorithm implements StyledExercise {

    matrix.structures.CDT.probe.SearchTable st = null;

    public BMH_Algorithm() {}


   long seed = 1;;

    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }

    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }

    public FDT[] init() {
        st = new matrix.structures.CDT.probe.SearchTable();
        VanillaTable t = new VanillaTable("PATTERN",1);
        Array d = st.getD();
        FDT[] tmp = { t, st, d, st };
        return tmp;
    }

    public String[] getStructureNames() {
        String[] tmp = { "Pattern P", "Text S", "Shift Table D", "Boyer-Moore-Horspool Algorithm" };
        return tmp;
    }

    public String getDescription() {
        return "1. Modify Pattern P in such a way that\n    a) the algorithm executes each line in code window\n        (Run algorithm by drag & dropping Pattern P into Text S.\n        Code lines appear red after the algorithm terminates\n        if they were executed and brown otherwise)\n    b) the algorithm examines each character in Text S\n        (the backgrounds for the examined characters are set blue).\n2. Describe the meaning of the code line 14\n    (see examples in other described code lines).";
    }

    public FDT[] solve() {
        /*
        List sl1, sl2, sl3, sl4;
        sl1 = new LinkedList();
        sl2 = new LinkedList();
        sl3 = new LinkedList();
        sl4 = new LinkedList();
        BinaryTree bt = (BinaryTree) bst.getElement();
        StringTokenizer pre = new StringTokenizer(Tranverse.tranversePreOrder(bt));
        StringTokenizer in = new StringTokenizer(Tranverse.tranverseInOrder(bt));
        StringTokenizer post = new StringTokenizer(Tranverse.tranversePostOrder(bt));
        StringTokenizer level = new StringTokenizer(Tranverse.tranverseLevelOrder(bt));
        String tmp;
        Animator a = Animator.getActiveAnimator();
        while(pre.hasMoreTokens()) {
            a.startOperation();
            try {
                tmp = pre.nextToken();
                sl1.append(tmp);
                tmp = in.nextToken();
                sl2.append(tmp);
                tmp = post.nextToken();
                sl3.append(tmp);
                tmp = level.nextToken();
                sl4.append(tmp);
            }catch(NoSuchElementException e) {
                Note.err(this, "Error during solve, one StringTokenizer shorter than pre");
            }
            a.endOperation();
        }
        if(in.hasMoreTokens() || post.hasMoreTokens() || level.hasMoreTokens())
            Note.err(this, "Error during solve, one StringTokenizer longer than pre");
        FDT[] ans = { sl1, sl2, sl3, sl4 };
        return ans;
        */
        return new FDT[] {
            new VanillaTable("OVER",1),
            new VanillaTable("NOTSOVERYSHORTEXAMPLETEXT",1)
                };
    }

    public FDT[] getAnswer() {
        FDT[] tmp = { st, st };
        return tmp;
    }

    // --- StyledExercise ---
    public String[] getStructureVisualisations() {
        return new String[] { null, "array", null, "code" };
    }
    public String[] getModelAnswerVisualisations() {
        return new String[] { null, "code" };
    }

    public FDT[] getInitialStructures() {
        throw new RuntimeException("not implemented");
    }

    static final long serialVersionUID = -7576576859774172745L;
}
