/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2003  Matrix project
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package content.exercises;

import java.util.Random;

import matrix.simulation.VisualTypeConf;
import matrix.structures.CDT.probe.FaultyBinSearchTree;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.Table;

public class BinTree_Faulty implements SimulationExerciseSelfAssessment, 
				       ButtonExercise, 
				       ModelAnswerNames, 
				       ConfigureVisualType {
    private Table t;
    private FaultyBinSearchTree tree;

    private String S;
    private static final int TABLE_LEN = 15;
    protected static Random rnd;
    public static final boolean DEBUG = false;

    public BinTree_Faulty() {
    }

    long seed = 1;

    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }

    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }

    public FDT[] init() {
	rnd = new Random(seed);
	StringBuffer bf = new StringBuffer( "ABCDEFGHIJKLMNOPQRSTUVXYZ" );
	for ( int i = 0; i < (25 - TABLE_LEN); i++ ) {
	    bf.deleteCharAt( rnd.nextInt( TABLE_LEN - i ) );
	}
	System.out.println("listana: "+bf);
	this.S = bf.toString();
	t = new Table( this.S );
	tree = new FaultyBinSearchTree();

        FDT[] s = {t, tree};
        return s;
    }

    public String[] getStructureNames() {
        String[] s = { "Stream of Keys", "BinSearchTree" };
        return s;
    }

    public String getDescription() {
        return "";
        //"Insert the following Keys into an initially empty AVL Tree";
    }

    public String[] buttonNames() {
        String[] s = {"delete key"}; 
        return s;
    }

    public String[] buttonCommands() {
        String[] s = {"reflectSelectedVisualType(delete)"};
        return s;
    }

    
    public String[] getModelAnswerNames() {
        String[] s = { "Broken BinSearchTree" };
        return s;
    }


    public SimulationExerciseModel getModelAnswer() {
	return this;
    }
    
    public FDT[] solve() {
	return new FDT[] {new Table("NO MODEL SOLUTION HERE")};
    }
    


    public FDT[] makeModelAnswer() {
	return solve();
    }



    public FDT[] getInitialStructures() {
        return new FDT[] { new Table(S), new FaultyBinSearchTree() };
    }
    
    public FDT[] getSimulatedStructures() {
        return new FDT[] { t, tree };
    }
    
    public FDT[] getAnswer() {
        FDT[] s = {tree};
        return s;
    }

    public int[] judge() {
	if (tree.isBroken())
	    return new int[] {1};
	else
	    return new int[] {0};
    }

    

    public int getMaxPoints() {
	return 1;
    }

    
    public VisualTypeConf[] conf() {
        VisualTypeConf tabl = new VisualTypeConf();
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
        VisualTypeConf tre = new VisualTypeConf();
        tre.enable("matrix.visual.VisualLayeredTree", VisualTypeConf.DROP_OPERATION);
        tre.enable("matrix.visual.VisualLayeredTree", VisualTypeConf.HIGHLIGHT_OPERATION);
        tre.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);

        return new VisualTypeConf[] { tabl, tre};
    }
    
    static final long serialVersionUID = -8436352103244731304L;
}
