/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*$Id: SimulationModelAnswer.java,v 1.4 2004/05/25 13:28:01 kstalnac Exp $*/

package content.exercises;

import matrix.structures.FDT.FDT;

/** Inteface for model answers for instances of <code>SimulationExercise</code>
 * The <code>solve()</code> -method is used to create a model animation of the
 * exercise.
 */
public interface SimulationModelAnswer extends SimulationExercise {
    /**
     * Initialises the structures needed for model answer and 
     * solves the exercise, returning a model answer of the
     * exercise.
     *
     * @see #getAnimator()
     */
    public FDT[] solve();

  /**
   * Initializes the structures used in the model answer with
   * the given input.
   */
  public FDT[] init(Object input);

}
