/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package content.exercises;

import matrix.animation.Animator;
import matrix.simulation.VisualTypeConf;
import matrix.structures.CDT.probe.*;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.*;
import matrix.util.RandomKey;

public class Stack_PreOrder implements SimulationExerciseModel, StyledExercise, ModelAnswerNames, ConfigureVisualType
				       /*, ButtonExercise*/ {

    private BinSearchTree bst = null;
    private ExerStackList l1;
    // private LinkedListImpl l1;
    private matrix.structures.CDT.probe.Stack st;
    
    public static final boolean DEBUG = true;
    private String keys;

    
    long seed = 1;;
    
    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }

    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }
    
    public String[] buttonNames() {
        String[] s = {"Hassu nappi"};
        return s;
    }

    public String[] buttonCommands() {
        String[] s = {"updateReferences"};
        return s;
    }
    
    public FDT[] init() {
        bst = new BinSearchTree();
        keys = RandomKey.createNoDuplicateUppercaseRandomKey(new java.util.Random(seed), 10);
        Table t = new Table(keys);
        bst.insert(t);
	st = new matrix.structures.CDT.probe.Stack();
        l1 = new ExerStackList(st);
        FDT[] tmp = {bst, st, l1 };

        return tmp;
    }

    public String[] getStructureVisualisations() {
        return new String[] { "layered tree", "visual array", "list" };
    }

    public String[] getModelAnswerVisualisations() {
        return new String[] { "visual array"  };
    }


  public String[] getStructureNames() {
    String[] tmp = { "Binary Tree", "Stack", "Traversing Order" };
    return tmp;
  }

  public String getDescription() {
    return "";
  }


   


  public FDT[] solve() {
    matrix.structures.CDT.probe.Stack resStack = new matrix.structures.CDT.probe.Stack();
    FDT[] fd = getInitialStructures();
    
    //    Table tbl = new Table(keys);
    BinaryTree bt = (BinaryTree)((BinSearchTree)fd[0]).getElement();//(BinaryTree) bst.getElement();
    
    

    /*
  1     while (S.notEmpty()) do
  2         next = S.pop()
  3         visit(next)
  4         if (next->right != NULL) S.push(next->right)
  5         if (next->left != NULL) S.push(next->left)
  

    */
    String order = "";
    java.util.Stack helpStack = new java.util.Stack();
    BinaryTree next,right,left;
    Animator a = Animator.getActiveAnimator();
    a.startOperation();	
    // Push
    helpStack.push(bt);
    resStack.insert(""+bt.getElement());
    System.out.println(resStack+":"+bt.getElement());
    a.endOperation();
    while(!helpStack.empty()) {
	a.startOperation();	
	// Pop
	order=order+helpStack;

	System.out.print(resStack+":");

	//resStack.delete(null);
	resStack.pop(null);

	next = (BinaryTree)helpStack.pop();
	System.out.println(resStack+":");
	a.endOperation();
	if (next == null) break;
	if (next.getRight() != null){
	    a.startOperation();	
	    right = next.getRight();
	    helpStack.push(right);
	    resStack.insert(""+right.getElement());
	    a.endOperation();
	}
	if (next.getLeft() != null) {
	    a.startOperation();
	    left=next.getLeft();
	    helpStack.push(left);
	    resStack.insert(""+left.getElement());
	    a.endOperation();
	}

    }
    if (DEBUG)
	System.out.println(order);

    FDT[] ans = {resStack };
    return ans;
  }




    public FDT[] makeModelAnswer() {
	return solve();
    }


  public String[] getModelAnswerNames() {
    String[] s = { "Binary Search Tree" };
    return s;
  }

  public FDT[] getInitialStructures() {
    Table tbl = new Table(keys);
    BinSearchTree tr = new BinSearchTree();
    tr.insert(tbl);
    return new FDT[] { tr, new QueueImpl() };
  }

  public FDT[] getSimulatedStructures() {
    return new FDT[] { bst, st, l1 };
  }


  public FDT[] getAnswer() {
    FDT[] tmp = {st };
    return tmp;
  }

  public SimulationExerciseModel getModelAnswer() {
    return null;
  }

  public VisualTypeConf[] conf() {
    VisualTypeConf tre = new VisualTypeConf();
    tre.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
    tre.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
    VisualTypeConf sta = new VisualTypeConf();
    sta.enable("matrix.visual.VisualArray", VisualTypeConf.DROP_OPERATION);
    sta.enable("matrix.visual.VisualArray", VisualTypeConf.HIGHLIGHT_OPERATION);
    sta.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
    sta.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
    VisualTypeConf lis = new VisualTypeConf();
    lis.enable("matrix.visual.VisualList", VisualTypeConf.DROP_OPERATION);
    lis.enable("matrix.visual.VisualList", VisualTypeConf.HIGHLIGHT_OPERATION);
    return new VisualTypeConf[] { tre, sta, lis};
  }
  static final long serialVersionUID = -2641400449334399953L;
}
