/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package content.exercises;

/**
 * A styled exercise is an <code>Exercise</code> where the creator of the
 * exercise can explicitly tell the visualisations for the used
 * data structures.
 *
 * @see matrix.visual.RepresentationFactory
 * @author Jussi Nikander
 */


public interface StyledExercise extends SimulationExercise {


    /**
     * Returns a <code>String</code> table telling the desired
     * visualisations of the structures of the <code>Exercise</code>.
     * @return a <code>String</code> table
     */
    public String[] getStructureVisualisations();

    /**
     * Retuns the desired visualisations of the model answer.
     * @return a <code>String</code> table telling the desired visualisations
     */
    public String[] getModelAnswerVisualisations();

    static final long serialVersionUID = -4038494743445282613L;
}
