/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: StyleSheet.java,v 1.5 2004/05/25 13:28:06 kstalnac Exp $ */

package matrix.decoration;

//import matrix.visual.LabelDecorator;
//import matrix.visual.ColorDecorator;
//import matrix.visual.InformationDecorator;
import java.io.Serializable;
/**
 * Interface for StyleSheet decorators. By using stylesheet decorators it is possible
 * to control the coloring and labeling of a visualsation of a data structure in
 * Matrix.
 * @see StyleSheetAdapter
 */

public interface StyleSheet extends Styled, LabelDecorator, ColorDecorator,
                                    InformationDecorator, Serializable {


    static final long serialVersionUID = -1448454264448534782L;
}
