/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: StaticTree.java,v 1.9 2004/05/25 13:28:13 kstalnac Exp $ */

package matrix.structures.FDT;

/**
 * Interface for static k'ary trees (e.g. array representation of binary trees where k=2).
 * The interface extends the StaticStructure interface that enables
 * the primitive simulation.
 */
public interface StaticTree extends StaticStructure {

    /** Determines the index of the father node.
     * The father of the root node is the root itself.
     * @return the index of the father of this node.
     */
    public int getFather(int node);

    /** Determines the number of nodes within this tree.
     * The nodes should be numbered from 0 to N-1.
     * @return the number of nodes within this tree.
     */
    public int getNrOfNodes();

    static final long serialVersionUID = 2788874119399070369L;
}
