/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: BinaryTree.java,v 1.7 2004/05/25 13:28:15 kstalnac Exp $ */

package matrix.structures.FDT.probe;

import matrix.structures.FDT.Tree;

public interface BinaryTree extends Tree { // CDT for binary tree

    /**
     * Returns the element value.
     * @return the contents of the element.
     */
    public Object getElement();

    /**
     * Sets the element value.
     * @param v the new value.
     */
    public void setElement(Object v);

    /**
     * Returns the left child.
     * @return the left child.
     */
    public BinaryTree getLeft();

    /**
     * Returns the right child.
     * @return the right child.
     */
  public BinaryTree getRight();

    /**
     * Sets the left child of this node.
     * @param p the new left child.
     */
    public void setLeft(BinaryTree p);

    /**
     * Set the right child of this node.
     * @param p the new right child.
     */
  public void setRight(BinaryTree p);

    /**
     * Tells if a node is leaf or internal node.
     * @return True if node is leaf
     */
  public boolean isLeaf();

  static final long serialVersionUID = -5160669267377408028L;
}
