/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.structures.simulationextensions;

/**
 * CallableMethods interface is a simulation extension 
 * that could be used to describe methods that could be
 * invoked by the user during the simulation process.
 */
public interface CallableMethods {

    /** Returns an array of strings describing the names of methods
     * that could be invoked during the simulation. The GUI allows the
     * user to select the method to be invoked. The methods should not
     * take any arguments.
     * @return array of string of method names */
    public String[] getCallableMethodNames();
}

