/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: CommandThread.java,v 1.7 2004/05/25 13:28:25 kstalnac Exp $ */

package matrix.util;

public class CommandThread extends Thread {
    private Command command;
    private int time = 200;
    
    public CommandThread(Command c) {
        //Note.out(this, "new commandThread");
        command = c;
    }
    
    public CommandThread(int t, Command c) {
        command = c;
        time = t;
    }
    
    public void run() {
        
        try {
            sleep(time);
            command.execute();
        } catch (InterruptedException e) {
            Note.out(this, "Interrupted");
        }
    }
}
