/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2002  Ari Korhonen and others
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package matrix.util.configuration;

//import java.awt.MenuBar;

/**
 * This class corresponds to a menubar in the Matrix configuration. Since
 * the actual menubar won't be created until one is requested, this class is
 * NOT a subclass of java.awt.MenuBar.
 */

public class CMenuBar extends ConfItem {

    private Class anchor;

    public CMenuBar(Class anchor) {
	super(ConfItem.MENUBAR);
	this.anchor = anchor;
    }

    public Class getAnchor() {
	return anchor;
    }
    
    public String toString() {
	return "MenuBar, anchor: " + anchor.toString();
    }


}
