/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: VisualAdjList.java,v 1.18 2004/05/26 08:06:06 vkaravir Exp $ */

package matrix.visual;

import matrix.structures.FDT.*;
import matrix.structures.FDT.probe.LinkedListImpl;
import matrix.structures.memory.VirtualArray;
import matrix.util.Note;

public class VisualAdjList extends VisualArray {
    Graph graph;
    Vertex[] vertex;
    
    public VisualAdjList(Graph g) {
	super(new VirtualArray());
	this.graph = g;
	//this.vertex = g.getVertices();
	setName("Adjacency List Representation of " + getArray().getClass());

        if (vertex != null)
            for (int i=0; i<vertex.length; i++) {
                Array array = new VirtualArray(vertex[i].getSuccessors());
                array.setObject(new LinkedListImpl(array),i);
            }
        else Note.err(this, "empty vertex[]; g = " + g);
    }

    protected LayoutSize doActualLayout() {
        // XXXXXXXX implement this? or always use VisualAdjencyList?
        return null;
    }

    public VisualType getRepresentation(Object fdt) {
        if (fdt instanceof LinkedList)
            return RepresentationFactory.getRepresentation(fdt, "List");
        else
            return super.getRepresentation(fdt);
    }

    public boolean isLabeled() {
        return true;
    }
}
