/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package prototype.ui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

//import applications.trakla2.datalogging.*;

import content.exercises.SimulationExercise;

import matrix.animation.Animator;
import matrix.structures.FDT.FDT;
import matrix.uitools.*;
import matrix.uitools.MenuFrame;
import matrix.util.*;
import matrix.util.configuration.MatrixConfiguration;

public class StartFrame extends MenuFrame {

  public StartFrame() {
    super();
    setTitle("Animation window");
  }

  public StartFrame(StructurePanel p) {
    super(p);
  }

  public Frame getNewFrame(StructurePanel p) {
    return new StartFrame(p);
  }

  public Frame getNewFrame() {
    return new StartFrame();
  }

  protected MenuBar createMenuBar() {
    MenuBar mb = super.createMenuBar();
    //mb.add(new ContentMenu(this));

    // this adds a dependency from prototype to Trakla2 application...
    //addTrakla2FileMenu(mb);

    return mb;
  }

  public static void main(String[] args) {
    if(args.length > 0 && !(args[0].equals(""))) {
        //matrix.util.Note.out(null, "Setting conf path");
        //matrix.visual.RepresentationFactory.setConfPath(args[0]);
        MatrixConfiguration.setConfPath(args[0]);
    }

    // find the configuration file as a resource
    // it doesn't matter what class is used below
    MatrixConfiguration.setInputStream(
        new SwapLabel().getClass().getResourceAsStream("/matrixconf.xml"));

    if(args.length > 1) {
        String arg = args[1].toLowerCase();
        if(arg.equals("t") || arg.equals("true"))
            MatrixConfiguration.setValidatingParser(true);
    }

    //if(args.length > 1 && args[1].equals("true"))
    //m.parse(true);
    //else
    //m.parse(false);
    //m.process();

    MatrixConfiguration m = MatrixConfiguration.getInstance();
    StartFrame mf = new StartFrame();
    ApplicationAdapter.setApplication(mf.getStructurePanel());
  }

  private Menu getMenu(MenuBar mb, String name) {

      for (int i = 0; i < mb.getMenuCount(); i++) {
          Menu m = mb.getMenu(i);
          if (m.getLabel().equals(name)) {
              return m;
          }
      }
      return null;
  }

    /*
  public MenuItem addTrakla2FileMenu() {
      MenuItem mi = new MenuItem("Open Trakla2 answer...");
      mi.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          openTrakla2Answer();
        }});
      return mi;
  }
    */

    /*
    private void openTrakla2Answer() {
      FileDialog fd = new FileDialog(this,
                                     "Select file",
                                     FileDialog.LOAD);
      fd.show();
      String fileName = fd.getDirectory() + fd.getFile();
      if (fileName == null)
          return;

      try {
            FileInputStream istream = new FileInputStream(new File(fileName));
            ObjectInputStream p = new ObjectInputStream(istream);
            ExerciseData data = (ExerciseData)p.readObject();
            System.out.println("Loaded: " + data);
            istream.close();

            if (data instanceof SubmissionData) {
                FDT[] ss =  ((SubmissionData)data).getStudentSolution().getStructures();
                Animator a = ((SubmissionData)data).getStudentSolution().getAnimator();
                getNewFrame(new StructurePanel(ss, a));
            } else if (data instanceof GradeData) {
                FDT[] ss =  ((GradeData)data).getStudentSolution().getStructures();
                Animator a = ((GradeData)data).getStudentSolution().getAnimator();
                getNewFrame(new StructurePanel(ss, a));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            Note.err(this, e.getMessage());
            Note.show(this, e.getMessage());

        }
      }
    */


      public void addMenuItem(Menu m, String itemName,
                              ActionListener callback) {
          MenuItem mi;

          m.add(mi = new MenuItem(itemName));
          mi.addActionListener(callback);
      }

    public void newExercise(SimulationExercise e) {
	e.setSeed(System.currentTimeMillis());
	ExerciseFrame ef = new ExerciseFrame(e);
	ef.show();
    }


}


