/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2001  Ari Korhonen and others
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * This is a very spartan implementation of a linked list
 * in java. This class can not be visualized using Matrix,
 * since it neither extends a Matrix probe nor implements
 * any Matrix concept interface
 */
public class PlainList {

  /** The contents of this list element */
  private Object contents;

  /** Link to next list element */
  private List next;

  /**
   * Default constructor, creates a new, empty
   * list element.
   */
  public PlainList() {
    this(null);
  }

  /**
   * A constructor that creates a new
   * list element with contents.
   *
   * @param contents the contents of this element
   */
  public PlainList(Object contents) {
    this.contents = null;
    next = null;
  }

  /**
   * Sets the contents of this list element.
   *
   * @param o the new contents of this element
   */
  public void setContents(Object o) {
    contents = o;
  }

  /**
   * Gets the contents of this element.
   *
   * @return the contents of this element
   */
  public Object getContents() {
    return contents;
  }

  /**
   * Sets the next list element.
   *
   * @param l the new next list element
   */
  public void setNextElement(PlainList l) {
    next = l;
  }

  /**
   * Returns the next list element.
   *
   * @return the next list element
   */
  public PlainList getNextElement() {
    return next;
  }

}
